package dbc.r15.sample.b4xxntjr;

import java.nio.ByteBuffer;

public class BQlineWrapper {
	private final int[] QLINE_B_BUFFER = {0, 132};
	private final int[] QLINE_B1 = {0, 5};
	private final int[] QLINE_B2 = {5, 3};
	private final int[] QLINE_B3 = {8, 5};
	private final int[] QLINE_B4 = {13, 2};
	private final int[] QLINE_B5 = {15, 1};
	private final int[] QLINE_B6 = {16, 4};	// this is binary for 2 bytes in Cobol Copybook
	private final int[] QLINE_B7 = {20, 4}; // this is binary for 2 bytes in Cobol Copybook
	private final int[] QLINE_B8 = {24, 5};
	private final int[] FILLER1 = {29,51};
	private final int[] QLINE_B9 = {80, 33};
	private final int[] QLINE_B9A = {80, 9};
	private final int[] QLINE_B9B = {89, 9};
	private final int[] QLINE_B9C = {98, 15};
	private final int[] FILLER2 = {113,19};	// It is 24 in the Cobol program
		// Variable to hold the binary data in the container
		private byte[] qData;
		// Set the binary value of the container
		public void setByteArray(byte[] data) { qData = data;}
		// Get the binary value of the container
		public byte[] getByteArray() {return qData;}
		public String getBuffer() {return new String(qData, 0, qData.length);
		}
		public void setBuffer(String newValue) {setNewValue(newValue, QLINE_B_BUFFER[0], QLINE_B_BUFFER[1]);
		}
		public void setQlineB1(String newValue) {setNewValue(newValue, QLINE_B1[0], QLINE_B1[1]);
		}
		public void setQlineB2(String newValue) {setNewValue(newValue, QLINE_B2[0], QLINE_B2[1]);
		}
		public void setQlineB3(String newValue) {setNewValue(newValue, QLINE_B3[0], QLINE_B3[1]);
		}
		public void setQlineB4(String newValue) {setNewValue(newValue, QLINE_B4[0], QLINE_B4[1]);
		}
		public void setQlineB5(String newValue) {setNewValue(newValue, QLINE_B5[0], QLINE_B5[1]);
		}
		public void setQlineB6(String newValue) {setNewValue(newValue, QLINE_B6[0], QLINE_B6[1]);
		}
		public void setQlineB7(String newValue) {setNewValue(newValue, QLINE_B7[0], QLINE_B7[1]);
		}
		public void setQlineB8(String newValue) {setNewValue(newValue, QLINE_B8[0], QLINE_B8[1]);
		}
		public void setQlineB9(String newValue) {setNewValue(newValue, QLINE_B9[0], QLINE_B9[1]);
		}
		public void setQlineB9A(String newValue) {setNewValue(newValue, QLINE_B9A[0], QLINE_B9A[1]);
		}
		public void setQlineB9B(String newValue) {setNewValue(newValue, QLINE_B9B[0], QLINE_B9B[1]);
		}
		public void setQlineB9C(String newValue) {setNewValue(newValue, QLINE_B9C[0], QLINE_B9C[1]);
		}
		
		private void setNewValue(String newValue, int index, int length) {
	/* 1. create a new byte array to hold the string called tData for temporary data
	 * 2. copy the new tData byte array to the cData byte array one byte at a time Left Justified
	 * 3. pad the cData with spaces up to the length passed in on the call 
	 */
	byte tData[] = newValue.getBytes();		// .step 1.
	int tDatalen = tData.length;
	int pDatalen = qData.length;
	int i = 0;
	while ( i < length && index < pDatalen)
	{
		if ( i < tDatalen )
			qData[index++] = tData[i];
		else
			qData[index++] = 0x40;			
		i++;
	}
}
		 
   		private void setShortNewValue(short newValue, int index, int length) {
    		/* 1. create a new byte array to hold the string called tData for temporary data
    		 * 2. copy the new tData byte array to the cData byte array one byte at a time
    		 * 3. pad the cData with spaces up to the length passed in on the call 
    		 */
			ByteBuffer buffer = ByteBuffer.allocate(2);
			buffer.putShort(newValue);
			buffer.flip();
			
    		byte tData[] = buffer.array();		// .step 1.
    		int tDatalen = tData.length;
    		int hDatalen = qData.length;
    		int i = 0;
    		while ( i < length && index < hDatalen)
    		{
    			if ( i < tDatalen )
    				qData[index++] = tData[i];
    			else
    				qData[index++] = 0x00;			
    			i++;
    		}
   		}
}
