package dbc.r15.sample.b4xxntjr;

import java.nio.ByteBuffer;

public class HstRqstAreaWrapper {
	private final int[] HST_BUFFER = {0, 256};
	private final int[] HST_CMD = {0, 5};
	private final int[] HST_TBLNM = {5, 3};
	private final int[] HST_KEYNM = {8, 5};
	private final int[] HST_RC = {13, 2};
	private final int[] HST_IRC = {15, 1};
	private final int[] HST_DBID = {16, 2};
	private final int[] HST_TBLID = {18, 2};
	private final int[] HST_RECID = {20,5};
	private final int[] HST_FILLER1 = {25, 51};
	private final int[] HST_KEY_VALUE = {76, 180};
	private final int[] HST_KEY_BID = {76, 9};
	private final int[] HST_KEY_AID = {85, 9};
	private final int[] HST_KEY_TRAN = {94, 15};
	private final int[] HST_KEY = {109, 147};
	 
		// Variable to hold the binary data in the container
		private byte[] hrData;
		// Set the binary value of the container
		public void setByteArray(byte[] data) { hrData = data;}
		// Get the binary value of the container
		public byte[] getByteArray() {return hrData;}
		// 
		public void setCommand(String newValue) {setNewValue(newValue, HST_CMD[0], HST_CMD[1]);
		}
		public String getCommand() {return new String(hrData,HST_CMD[0], HST_CMD[1]);
			}
		public void setTableName(String newValue) {setNewValue(newValue, HST_TBLNM[0], HST_TBLNM[1]);
		}
		public String getTableName() {return new String(hrData,HST_TBLNM[0], HST_TBLNM[1]);
			}
		public void setKeyName(String newValue) {setNewValue(newValue, HST_KEYNM[0], HST_KEYNM[1]);
		}
		public String getKeyName() {return new String(hrData,HST_KEYNM[0], HST_KEYNM[1]);
			}
		public void setReturnCode(String newValue) {setNewValue(newValue, HST_RC[0], HST_RC[1]);
		}
		public String getReturnCode() {return new String(hrData,HST_RC[0], HST_RC[1]);
			}
		public void setiReturnCode(String newValue) {setNewValue(newValue, HST_IRC[0], HST_IRC[1]);
		}
		public String getiReturnCode() {return new String(hrData,HST_IRC[0], HST_IRC[1]);
			}
		public void setDbid(short newValue) {setShortNewValue(newValue, HST_DBID[0], HST_DBID[1]);
		}
		public String getDbid() {return new String(hrData,HST_DBID[0], HST_DBID[1]);
			}
		public void setTblid(String newValue) {setNewValue(newValue, HST_TBLID[0], HST_TBLID[1]);
		}
		public String getTblid() {return new String(hrData,HST_TBLID[0], HST_TBLID[1]);
			}
		public void setRecid(String newValue) {setNewValue(newValue, HST_RECID[0], HST_RECID[1]);
		}
		public String getRecid() {return new String(hrData,HST_RECID[0], HST_RECID[1]);
			}
		public void setKeyValue(String newValue) {setNewValue(newValue, HST_KEY_VALUE[0], HST_KEY_VALUE[1]);
		}
		public String getKeyValue() {return new String(hrData,HST_KEY_VALUE[0], HST_KEY_VALUE[1]);
			}
		public void setKeyBid(String newValue) {setNewValue(newValue, HST_KEY_BID[0], HST_KEY_BID[1]);
		}
		public String getKeyBid() {return new String(hrData,HST_KEY_BID[0], HST_KEY_BID[1]);
			}
		public void setKeyAid(String newValue) {setNewValue(newValue, HST_KEY_AID[0], HST_KEY_AID[1]);
		}
		public String getKeyAid() {return new String(hrData,HST_KEY_AID[0], HST_KEY_AID[1]);
			}
		public void setTran(String newValue) {setNewValue(newValue, HST_KEY_TRAN[0], HST_KEY_TRAN[1]);
		}
		public String getTran() {return new String(hrData,HST_KEY_TRAN[0], HST_KEY_TRAN[1]);
			}
		public void setKey(String newValue) {setNewValue(newValue, HST_KEY[0], HST_KEY[1]);
		}
		public String getKey() {return new String(hrData,HST_KEY[0], HST_KEY[1]);
			}
         
        /* Inserts a value into the main byte[] and pads with spaces if necessary.
    	 * Note: values will be left justified
    	 */
    	private void setNewValue(String newValue, int index, int length) {
    		/**** Important : We converted a 4-character field (string with a value such as a 0400) and  
    		 converted it to short using urs = Short.valueOf(caW.getDbid()); then came
    		 here with the short object and initialized the two byte DBID with this value
    		 ****/
    		byte tData[] = newValue.getBytes();		// .step 1.
    		int tDatalen = tData.length;
    		int cDatalen = hrData.length;
    		int i = 0;
    		while ( i < length && index < cDatalen)
    		{
    			if ( i < tDatalen )
    				hrData[index++] = tData[i];
    			else
    				hrData[index++] = 0x40;			
    			i++;
    		}
    	}
    		private void setShortNewValue(short newValue, int index, int length) {
    			ByteBuffer buffer = ByteBuffer.allocate(2);
    			buffer.putShort(newValue);
    			buffer.flip();
    			
        		byte tData[] = buffer.array();		// .step 1.
        		int tDatalen = tData.length;
        		int hDatalen = hrData.length;
        		int i = 0;
        		while ( i < length && index < hDatalen)
        		{
        			if ( i < tDatalen )
        				hrData[index++] = tData[i];
        			else
        				hrData[index++] = 0x00;			
        			i++;
        		}
}
}
